/***************************************************************************
 *              Filename : testCurveWindow.cpp
 *                   Begin : 2008-08-14 08:46:43
 *                 Project : CurveWindow
 *                  Author : Wu Yin
 ***************************************************************************/
#include <gtk/gtk.h>
#include <iostream>
#include "CurveWindow.h"
using  namespace std;

/***************************************************************************
 * add by Wu Yin, 2008-08-14 08:55:09
 ***************************************************************************/
static void timer_1_test(gpointer data)
{
	CurveWindow *cw = (CurveWindow *)data;
	cw->draw();

/* !!! Look Here !!!
 * Uncomment each statement of the following, the timer will run correctly, WHY? 
 */
//	printf("timer_1_test() \n");
//	gtk_widget_draw(cw->get_root_widget(), NULL);
}

/***************************************************************************
 * add by Wu Yin, 2008-08-14 08:55:09
 ***************************************************************************/
static void create_gui()
{
	GtkWidget *drawing_win;
	GtkWidget *root_win;
	GtkWidget *root_table;
	CurveWindow *cw;
	GdkColor bg, fg;

	// Create root_window
	root_win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_default_size(GTK_WINDOW(root_win), 800, 600);
	g_signal_connect(GTK_OBJECT(root_win), "destroy", G_CALLBACK(gtk_main_quit), NULL);

	// Create root table container
	root_table = gtk_table_new(10, 10, TRUE);
	gtk_container_add(GTK_CONTAINER(root_win), root_table);

	// Create Drawing place 1, and add to the root table
	cw = new CurveWindow();
	drawing_win = cw->create_drawing_win();
	g_timeout_add(1000, (GSourceFunc)timer_1_test, cw);
	gtk_table_attach_defaults(GTK_TABLE(root_table), drawing_win, 0, 2, 0, 2);

	gtk_widget_show_all(root_win);
}

/***************************************************************************
 * add by Wu Yin, 2008-08-14 08:55:09
 ***************************************************************************/
int main(int argc, char *argv[])
{
	gtk_init(&argc, &argv);
	create_gui();
	gtk_main();
	return 0; 
}

